/* Generated by re2c 0.9.8 on Tue Jan 31 14:48:33 2006 */
#line 1 "src/net/URL.re"
/*
 * Copyright (C) 2006 Tildeslash Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation.
 *
 * There are special exceptions to the terms and conditions of the GPL 
 * as it is applied to this software. View the full text of the exception
 * in the file EXCEPTIONS accompanying this software distribution.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */


#include "Config.h"

#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <limits.h>

#include "Util.h"
#include "URL.h"


/**
 * Implementation of the URL interface. URL_create() does not 
 * handle wide character code but URL_new() does. The scanner 
 * handle ISO Latin 1 or UTF-8 encoded url's transparently.
 *
 * @version \$Id: URL.re,v 1.16 2006/01/30 17:16:26 hauk Exp $
 * @file
 */


/* ----------------------------------------------------------- Definitions */

typedef struct params {
        char *name;
        char *value;
        struct params *next;
} *param_t;

#define T URL_T
struct T {
	int port;
       	char *ref;
	char *path;
	char *host;
	char *user;
        char *qptr;
	char *query;
	char *portStr;
	char *protocol;
	char *password;
	char *toString;
        param_t params;
        char **paramNames;
	uchar_T *data;
	uchar_T *buffer;
	uchar_T *marker, *limit, *token;
        /* Keep the above align with zild URL_T */
};

/* Unsafe URL characters: <>\"#%{}|\\^[] ` */
static const uchar_T urlunsafe[256]= {
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 0, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 
	1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
};

#define BUFFER_SIZE 8192
#define UNKNOWN_PORT         -1
#define MYSQL_DEFAULT_PORT   3306
#define YYCTYPE       uchar_T
#define YYCURSOR      U->buffer  
#define YYLIMIT       U->limit  
#define YYMARKER      U->marker
#define YYFILL(n)     
#define SET_PROTOCOL(PORT) *(YYCURSOR-3)=0; \
	U->protocol=U->token;U->port=PORT;goto parse
#define STRDUP(s) (s?Util_strdup(s):NULL)
#define STRNDUP(s, n) (s?Util_strndup(s, n):NULL)
	

/* ------------------------------------------------------------ Prototypes */


static int x2b(char *x);
static int parseURL(T U);
static void setParams(T U);
static char *b2x(int b, char *x);
static void freeParams(param_t *p);


/* ----------------------------------------------------- Protected methods */

#ifdef ZILD_PACKAGE_PROTECTED
#pragma GCC visibility push(hidden)
#endif

T URL_new(const char *url) {
	T U;
	if(! (url && *url))
		return NULL;
	NEW(U);
	U->data= (uchar_T*)Util_strdup(url);
	YYCURSOR= U->data;
	U->port= UNKNOWN_PORT;
	YYLIMIT= U->data + strlen(U->data);
	if(parseURL(U)) {
                if(U->query) 
                        setParams(U);
		return U;
        } 
	URL_free(&U);
	return NULL;
}


T URL_create(const char *url, ...) {
	int r;
	va_list ap;
	uchar_T buf[BUFFER_SIZE];
	if(! (url && *url))
		return NULL;
	va_start(ap, url);
	r= vsnprintf(buf, BUFFER_SIZE, url, ap);
	va_end(ap);
	if(r<0) 
		return NULL;
	return URL_new(buf);
}


void URL_free(T *U) {
	assert(U && *U);
        if((*U)->params) freeParams(&(*U)->params);
        FREE((*U)->paramNames);
	FREE((*U)->toString);
	FREE((*U)->portStr);
	FREE((*U)->query);
	FREE((*U)->data);
	FREE((*U)->host);
	FREE(*U);
}


/* ------------------------------------------------------------ Properties */


const char *URL_getProtocol(T U) {
	assert(U);
	return U->protocol;
}


const char *URL_getUser(T U) {
	assert(U);
	return U->user;
}


const char *URL_getPassword(T U) {
	assert(U);
	return U->password;
}


const char *URL_getHost(T U) {
	assert(U);
	return U->host;
}


int URL_getPort(T U) {
	assert(U);
	return U->port;
}


const char *URL_getPath(T U) {
	assert(U);
	return U->path;
}


const char *URL_getQueryString(T U) {
	assert(U);
	return U->query;
}


const char **URL_getParameterNames(T U) {
        assert(U);
        if(U->params && U->paramNames==NULL) {
                param_t p;
                int i= 0, len= 0;
                for(p= U->params; p; p= p->next) len++;
                U->paramNames= ALLOC((len + 1) * sizeof *(U->paramNames));
                for(p= U->params; p; p= p->next) {
                        U->paramNames[i++]= p->name;
                }
                U->paramNames[i]= NULL;
        }
	return (const char **)U->paramNames;
}


const char *URL_getParameter(T U, const char *name) {
	assert(U);
        if(U->params && name) {
                param_t p;
                for(p= U->params; p; p= p->next) {
                        if(Util_isByteEqual(p->name, name))
                                return p->value;
                }
        }
        return NULL;
}


const char *URL_toString(T U) {
	assert(U);
	if(U->toString==NULL) {
		U->toString= Util_getString("%s://%s%s%s%s%s%s%s%s%s%s", 
					    U->protocol,
					    U->user?U->user:"",
					    U->password?":":"",
					    U->password?U->password:"",
					    U->user?"@":"",
					    U->host?U->host:"",
					    U->portStr?":":"",
					    U->portStr?U->portStr:"",
					    U->path?U->path:"",
					    U->query?"?":"",
					    U->query?U->query:""); 
	}
	return U->toString;
}


char *URL_unescape(char *url) {
	register int x,y;
	if(! (url && *url)) return url;
	for(x=0,y=0;url[y];++x,++y) {
		if((url[x]= url[y]) == '%') {
			url[x]= x2b(&url[y+1]);
			y+=2;
		}
	}
	url[x] = '\0';
	return url;
}


char *URL_escape(const char *url) {
        char *escaped, *p;
	if(!url)
		return NULL;
	p= escaped= ALLOC(3 * strlen(url) + 1);
	while(*url) {
		if(urlunsafe[(unsigned char)(*url)]) {
			p= b2x(*url, p);
		} else {
			*(p++)= *url;
		}
		url++;
	}
	*p= 0;
	return escaped;
}


char *URL_normalize(char *path) {
        char c;
	int i,j;
	if(!path)
		return NULL;
        for(i=j=0; (c=path[i]); ++i) {
                if(c=='/') {
                        while(path[i+1]=='/') ++i;	
                } else if(c=='.' && j && path[j-1]=='/') {
                        if(path[i+1]=='.' && (path[i+2]=='/' || path[i+2]==0)) {
                                if(j>1)
                                        for(j-=2; path[j]!='/' && j>0; --j);
                                i+=2;
                        } else if(path[i+1]=='/' || path[i+1]==0) {
                                ++i;
                                continue;
                        } else
                                c=':';
                }
                if(!(path[j]=path[i])) break; ++j;
	}
	if(!j) { path[0]='/'; j=1; }
	path[j]=0;
	if(path[0]=='/' && path[1]=='/') {
		for(i=j=0;(c=path[i]); ++i) {
			if(c=='/') {
				while(path[i+1]=='/') ++i;	
			}
			if(!(path[j]=path[i])) break; 
			++j;
		}
		path[j]=0;
	}
	return path;
}

#ifdef ZILD_PACKAGE_PROTECTED
#pragma GCC visibility pop
#endif

/* ------------------------------------------------------- Private methods */


static int parseURL(T U) {
	#line 352 "src/net/URL.re"

proto:
	if(YYCURSOR >= YYLIMIT)
		return FALSE;
	U->token=  YYCURSOR;
	{
	static unsigned char yybm[] = {
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128,   0,   0,   0,   0,   0,   0, 
	  0, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128,   0,   0,   0,   0,   0, 
	  0, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	};

#line 386 "<stdout>"
{
	YYCTYPE yych;
	unsigned int yyaccept;
	goto yy0;
	++YYCURSOR;
yy0:
	if((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if(yych <= '9'){
		if(yych <= 0x0D){
			if(yych <= 0x08)	goto yy8;
			if(yych <= 0x0A)	goto yy2;
			if(yych <= 0x0C)	goto yy8;
			goto yy2;
		} else {
			if(yych == ' ')	goto yy2;
			if(yych <= '/')	goto yy8;
			goto yy7;
		}
	} else {
		if(yych <= 'e'){
			if(yych <= '@')	goto yy8;
			if(yych <= 'Z')	goto yy7;
			if(yych <= '`')	goto yy8;
			goto yy7;
		} else {
			if(yych <= 'l'){
				if(yych <= 'f')	goto yy4;
				goto yy7;
			} else {
				if(yych <= 'm')	goto yy6;
				if(yych <= 'z')	goto yy7;
				goto yy8;
			}
		}
	}
yy2:	++YYCURSOR;
	goto yy3;
yy3:
#line 359 "src/net/URL.re"
{
                        goto proto;
		   }
#line 430 "<stdout>"
yy4:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'Z'){
		if(yych <= '/')	goto yy5;
		if(yych <= ':')	goto yy12;
		if(yych >= 'A')	goto yy12;
		goto yy5;
	} else {
		if(yych <= 'h'){
			if(yych >= 'a')	goto yy12;
			goto yy5;
		} else {
			if(yych <= 'i')	goto yy24;
			if(yych <= 'z')	goto yy12;
			goto yy5;
		}
	}
yy5:
#line 375 "src/net/URL.re"
{
                      	goto proto;
                   }
#line 453 "<stdout>"
yy6:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'Z'){
		if(yych <= '/')	goto yy5;
		if(yych <= ':')	goto yy12;
		if(yych <= '@')	goto yy5;
		goto yy12;
	} else {
		if(yych <= 'x'){
			if(yych <= '`')	goto yy5;
			goto yy12;
		} else {
			if(yych <= 'y')	goto yy16;
			if(yych <= 'z')	goto yy12;
			goto yy5;
		}
	}
yy7:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '@'){
		if(yych <= '/')	goto yy5;
		if(yych <= ':')	goto yy12;
		goto yy5;
	} else {
		if(yych <= 'Z')	goto yy12;
		if(yych <= '`')	goto yy5;
		if(yych <= 'z')	goto yy12;
		goto yy5;
	}
yy8:	yych = *++YYCURSOR;
	goto yy5;
yy9:	yych = *++YYCURSOR;
	if(yych == '/')	goto yy13;
	goto yy10;
yy10:	YYCURSOR = YYMARKER;
	switch(yyaccept){
	case 0:	goto yy5;
	}
yy11:	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	goto yy12;
yy12:	if(yybm[0+yych] & 128) {
		goto yy11;
	}
	if(yych == ':')	goto yy9;
	goto yy10;
yy13:	yych = *++YYCURSOR;
	if(yych != '/')	goto yy10;
	goto yy14;
yy14:	++YYCURSOR;
	goto yy15;
yy15:
#line 371 "src/net/URL.re"
{
                      	SET_PROTOCOL(UNKNOWN_PORT);
                   }
#line 511 "<stdout>"
yy16:	yych = *++YYCURSOR;
	if(yych != 's')	goto yy12;
	goto yy17;
yy17:	yych = *++YYCURSOR;
	if(yych != 'q')	goto yy12;
	goto yy18;
yy18:	yych = *++YYCURSOR;
	if(yych != 'l')	goto yy12;
	goto yy19;
yy19:	yych = *++YYCURSOR;
	if(yych != ':')	goto yy12;
	goto yy20;
yy20:	yych = *++YYCURSOR;
	if(yych != '/')	goto yy10;
	goto yy21;
yy21:	yych = *++YYCURSOR;
	if(yych != '/')	goto yy10;
	goto yy22;
yy22:	++YYCURSOR;
	goto yy23;
yy23:
#line 367 "src/net/URL.re"
{
                      	SET_PROTOCOL(MYSQL_DEFAULT_PORT);
                   }
#line 537 "<stdout>"
yy24:	yych = *++YYCURSOR;
	if(yych != 'l')	goto yy12;
	goto yy25;
yy25:	yych = *++YYCURSOR;
	if(yych != 'e')	goto yy12;
	goto yy26;
yy26:	yych = *++YYCURSOR;
	if(yych != ':')	goto yy12;
	goto yy27;
yy27:	yych = *++YYCURSOR;
	if(yych != '/')	goto yy10;
	goto yy28;
yy28:	yych = *++YYCURSOR;
	if(yych != '/')	goto yy10;
	goto yy29;
yy29:	++YYCURSOR;
	goto yy30;
yy30:
#line 363 "src/net/URL.re"
{
			SET_PROTOCOL(UNKNOWN_PORT);
                   }
#line 560 "<stdout>"
}
}
#line 378 "src/net/URL.re"

parse:
	if(YYCURSOR >= YYLIMIT)
		return TRUE;
	U->token=  YYCURSOR;
	{
	static unsigned char yybm[] = {
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	112, 112, 112,  16, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 240, 112, 112, 
	248, 248, 248, 248, 248, 248, 248, 248, 
	248, 248, 112,  16, 112, 112, 112,  16, 
	 64, 240, 240, 240, 240, 240, 240, 240, 
	240, 240, 240, 240, 240, 240, 240, 240, 
	240, 240, 240, 240, 240, 240, 240, 240, 
	240, 240, 240, 112, 112, 112, 112, 112, 
	112, 240, 240, 240, 240, 240, 240, 240, 
	240, 240, 240, 240, 240, 240, 240, 240, 
	240, 240, 240, 240, 240, 240, 240, 240, 
	240, 240, 240, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	112, 112, 112, 112, 112, 112, 112, 112, 
	};

#line 605 "<stdout>"
{
	YYCTYPE yych;
	unsigned int yyaccept;
	goto yy31;
	++YYCURSOR;
yy31:
	if((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if(yych <= '.'){
		if(yych <= 0x0D){
			if(yych <= 0x08)	goto yy43;
			if(yych <= 0x0A)	goto yy33;
			if(yych <= 0x0C)	goto yy43;
			goto yy33;
		} else {
			if(yych <= ' '){
				if(yych <= 0x1F)	goto yy43;
				goto yy35;
			} else {
				if(yych == '-')	goto yy38;
				goto yy36;
			}
		}
	} else {
		if(yych <= '?'){
			if(yych <= '/')	goto yy40;
			if(yych <= '9')	goto yy38;
			if(yych <= ':')	goto yy42;
			goto yy36;
		} else {
			if(yych <= 'Z'){
				if(yych <= '@')	goto yy43;
				goto yy38;
			} else {
				if(yych <= '`')	goto yy36;
				if(yych <= 'z')	goto yy38;
				goto yy36;
			}
		}
	}
yy33:	++YYCURSOR;
	goto yy34;
yy34:
#line 385 "src/net/URL.re"
{ 
                        goto parse; 
                   }
#line 653 "<stdout>"
yy35:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 0x1F)	goto yy34;
	goto yy50;
yy36:	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych >= ' ')	goto yy50;
	goto yy37;
yy37:
#line 429 "src/net/URL.re"
{
                      	return TRUE;
                   }
#line 667 "<stdout>"
yy38:	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yybm[0+yych] & 128) {
		goto yy61;
	}
	if(yych <= 0x1F)	goto yy39;
	if(yych == '.')	goto yy60;
	goto yy50;
yy39:
#line 401 "src/net/URL.re"
{
                        U->host= STRNDUP(U->token, (YYCURSOR - U->token));
                        goto parse; 
                   }
#line 682 "<stdout>"
yy40:	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy53;
yy41:
#line 415 "src/net/URL.re"
{
                        *YYCURSOR= 0;
                        U->path= U->token;
                        URL_normalize(U->path);
                        return TRUE;
                   }
#line 694 "<stdout>"
yy42:	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yybm[0+yych] & 8) {
		goto yy44;
	}
	if(yych <= 0x1F)	goto yy37;
	goto yy50;
yy43:	yych = *++YYCURSOR;
	goto yy37;
yy44:	yyaccept = 4;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy45;
yy45:	if(yybm[0+yych] & 8) {
		goto yy44;
	}
	if(yych <= 0x1F)	goto yy46;
	if(yych == '@')	goto yy47;
	goto yy49;
yy46:
#line 406 "src/net/URL.re"
{
                        int e= FALSE;
                        U->portStr= STRNDUP(U->token+1, (YYCURSOR-U->token-1));
                        U->port= Util_parseInt(U->portStr, &e);
                        if(e)
                                U->port= UNKNOWN_PORT;
                        goto parse; 
                   }
#line 725 "<stdout>"
yy47:	++YYCURSOR;
	goto yy48;
yy48:
#line 389 "src/net/URL.re"
{
                        char *p;
                        *(YYCURSOR-1)= 0;
                        U->user= U->token;
                        p= strchr(U->user, ':');
                        if(p) {
                                *(p++)= 0;
                                U->password= p;
                        }
                        goto parse; 
                   }
#line 741 "<stdout>"
yy49:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy50;
yy50:	if(yybm[0+yych] & 16) {
		goto yy49;
	}
	if(yych >= '@')	goto yy47;
	goto yy51;
yy51:	YYCURSOR = YYMARKER;
	switch(yyaccept){
	case 0:	goto yy34;
	case 2:	goto yy39;
	case 4:	goto yy46;
	case 3:	goto yy41;
	case 5:	goto yy56;
	case 1:	goto yy37;
	}
yy52:	yyaccept = 3;
	YYMARKER = ++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	goto yy53;
yy53:	if(yybm[0+yych] & 32) {
		goto yy52;
	}
	if(yych <= '"')	goto yy41;
	if(yych <= '>')	goto yy49;
	if(yych <= '?')	goto yy55;
	goto yy54;
yy54:	yych = *++YYCURSOR;
	if(yych <= '#'){
		if(yych <= 0x1F)	goto yy48;
		if(yych <= '"')	goto yy58;
		goto yy48;
	} else {
		if(yych == ';')	goto yy48;
		goto yy58;
	}
yy55:	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych >= ' ')	goto yy50;
	goto yy56;
yy56:
#line 422 "src/net/URL.re"
{
                        *(YYCURSOR-1)= 0;
                        U->path= U->token;
                        URL_normalize(U->path);
                        goto query; 
                   }
#line 793 "<stdout>"
yy57:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy58;
yy58:	if(yybm[0+yych] & 64) {
		goto yy57;
	}
	if(yych <= '>')	goto yy41;
	goto yy59;
yy59:	yych = *++YYCURSOR;
	goto yy56;
yy60:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yych <= '9'){
		if(yych <= ','){
			if(yych <= 0x1F)	goto yy51;
			goto yy49;
		} else {
			if(yych <= '-')	goto yy63;
			if(yych <= '/')	goto yy49;
			goto yy63;
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '?')	goto yy49;
			if(yych <= '@')	goto yy47;
			goto yy63;
		} else {
			if(yych <= '`')	goto yy49;
			if(yych <= 'z')	goto yy63;
			goto yy49;
		}
	}
yy61:	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy62;
yy62:	if(yybm[0+yych] & 128) {
		goto yy61;
	}
	if(yych <= '.'){
		if(yych <= 0x1F)	goto yy39;
		if(yych <= '-')	goto yy49;
		goto yy60;
	} else {
		if(yych == '@')	goto yy47;
		goto yy49;
	}
yy63:	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy64;
yy64:	if(yych <= '9'){
		if(yych <= '-'){
			if(yych <= 0x1F)	goto yy39;
			if(yych <= ',')	goto yy49;
			goto yy63;
		} else {
			if(yych <= '.')	goto yy60;
			if(yych <= '/')	goto yy49;
			goto yy63;
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '?')	goto yy49;
			if(yych <= '@')	goto yy47;
			goto yy63;
		} else {
			if(yych <= '`')	goto yy49;
			if(yych <= 'z')	goto yy63;
			goto yy49;
		}
	}
}
}
#line 433 "src/net/URL.re"

query:
	if(YYCURSOR >= YYLIMIT)
		return TRUE;
	U->token=  YYCURSOR;
	{
	static unsigned char yybm[] = {
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	128, 128, 128,   0, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	};

#line 914 "<stdout>"
{
	YYCTYPE yych;
	goto yy65;
	++YYCURSOR;
yy65:
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if(yych <= 0x1F)	goto yy69;
	if(yych == '#')	goto yy69;
	goto yy68;
yy67:
#line 440 "src/net/URL.re"
{
                        *YYCURSOR= 0;
                        U->qptr= U->token;
                        U->query= STRNDUP(U->token, (YYCURSOR-U->token));
                        goto query;
                   }
#line 933 "<stdout>"
yy68:	yych = *++YYCURSOR;
	goto yy72;
yy69:	++YYCURSOR;
	goto yy70;
yy70:
#line 447 "src/net/URL.re"
{ 
                      return TRUE;     
                   }
#line 943 "<stdout>"
yy71:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy72;
yy72:	if(yybm[0+yych] & 128) {
		goto yy71;
	}
	goto yy67;
}
}
#line 451 "src/net/URL.re"

        return FALSE;
}


/*
 * Scan the query string for params. 
 * RFC 2396/3.3 URL path parameters are ignored in this version
 */
static void setParams(T U) {
	uchar_T *l, *s, *t;
        param_t param= NULL;
        s= U->qptr;
	l= s + strlen(s);
#undef YYCTYPE
#undef YYCURSOR
#undef YYLIMIT
#undef YYMARKER
#undef YYFILL
#define YYCTYPE         uchar_T
#define YYCURSOR        s
#define YYLIMIT         l
#define YYMARKER        s
#define YYFILL(n)
start:
        if(YYCURSOR >= YYLIMIT)
                return;
	t= YYCURSOR;
	{
	static unsigned char yybm[] = {
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	192, 192, 192, 192, 192, 192, 128, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192,  64, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	};

#line 1019 "<stdout>"
{
	YYCTYPE yych;
	goto yy73;
	++YYCURSOR;
yy73:
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if(yych <= 0x1F)	goto yy79;
	if(yych == '=')	goto yy77;
	goto yy75;
yy75:	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy87;
yy76:
#line 481 "src/net/URL.re"
{
                        /* No parameters, but a querystring */
                        return;
                   }
#line 1039 "<stdout>"
yy77:	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy82;
yy78:
#line 494 "src/net/URL.re"
{
                        *t++= 0;
                        if(*(YYCURSOR-1)=='&')
                                *(YYCURSOR-1)= 0;
                        if(param==NULL) /* format error */
                                return; 
                         param->value= t;
			 goto start;
                   }
#line 1054 "<stdout>"
yy79:	++YYCURSOR;
	goto yy80;
yy80:
#line 504 "src/net/URL.re"
{ 
	                 return;
		   }
#line 1062 "<stdout>"
yy81:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy82;
yy82:	if(yybm[0+yych] & 64) {
		goto yy81;
	}
	if(yych <= '%')	goto yy78;
	goto yy83;
yy83:	yych = *++YYCURSOR;
	goto yy78;
yy84:	++YYCURSOR;
	goto yy85;
yy85:	YYCURSOR -= 1;
#line 486 "src/net/URL.re"
{
                        NEW(param);
                        param->name= t;
                        param->next= U->params;
                        U->params= param;
                        goto start;
                   }
#line 1085 "<stdout>"
yy86:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy87;
yy87:	if(yybm[0+yych] & 128) {
		goto yy86;
	}
	if(yych <= '<')	goto yy76;
	goto yy84;
}
}
#line 507 "src/net/URL.re"

}


static int x2b(char *x) {
	register int b;
	b= ((x[0] >= 'A') ? ((x[0] & 0xdf) - 'A')+10 : (x[0] - '0'));
	b*= 16;
	b+= (x[1] >= 'A' ? ((x[1] & 0xdf) - 'A')+10 : (x[1] - '0'));
	return b;
}


static char *b2x(int b, char *x) {
	static const char b2x_table[] = "0123456789ABCDEF";
	*x++ = '%';
	*x++ = b2x_table[b >> 4];
	*x++ = b2x_table[b & 0xf];
	return x;
}


static void freeParams(param_t *p) {
        if((*p)->next)
                freeParams(&(*p)->next);
        FREE(*p);
}
